proc Bye
rem *** Close all files that may be open.  NB: An error ***              
rem *** will be caused by this proc and must be trapped ***             
while 1: close : endwhile 
endproc 
proc Check
rem *** Checks if an error occurred opening files ***            
rem *** If so closes files and retries.           ***             
if errnum(): error Bye: cls 
print ink 2;"Error in opening files"
Start: endif 
endproc 
proc Chop;X$,n,Delim$
rem *** Sets C$ to given string with first n 'words' removed ***             
local Words,Dlim
let Words=n: let C$=X$
let Dlim=instr(X$,Delim$)
while Words
if not Dlim or Dlim>=len(C$): let C$="": return : endif 
let C$=C$(Dlim+1 to )
let Dlim=instr(C$,Delim$)
let Words=Words-1
endwhile 
endproc 
proc DelFam;Fam
rem *** Deletes the records in all files  associated with ***              
rem *** family "Fam"   (Does not delete "people" records) ***              
use "F": locate Fam
if Fam<>F.Family: return : endif 
DelMar;F.Father,Fam
DelMar;F.Mother,Fam
let C$=F.Children$
while val(C$)
DelPar;val(C$),Fam
Chop;C$,1,","
endwhile 
delete "F"
print "*** Family DELETED ***"
endproc 
proc DelMar;Who,Fam
rem *** Deletes marriage of "Who" if in family "Fam" ***            
use "M": locate Who
while M.RefNo=Who
if M.Family=Fam
delete "M"
else : next : endif 
endwhile 
endproc 
proc DelPar;Who,Fam
rem *** Deletes parents of "Who" if in family "Fam" ***            
use "Pa": locate Who
while Pa.RefNo=Who
if Pa.Family=Fam
delete "Pa"
else : next : endif 
endwhile 
endproc 
proc FileNames
rem *** Gets names of data files (Defaults given) ***               
input "     Name of  'people'  file (Peo_dbf): ";Peo$
input "     Name of 'families' file (Fam_dbf): ";Fam$
input "     Name of 'parents'  file (Par_dbf): ";Par$
input "     Name of 'marriage' file (Mar_dbf): ";Mar$
if Peo$="": let Peo$="Peo": endif 
if Fam$="": let Fam$="Fam": endif 
if Par$="": let Par$="Par": endif 
if Mar$="": let Mar$="Mar": endif 
endproc 
proc GetPerson
rem *** Finds record of person (or inserts one) ***                                   
let yes=0
while not yes
getrec;"P"
if not yes
YesNo;"Do you want to enter new person? "
if yes:InPerson: endif 
endif 
endwhile 
endproc 
proc GetRec;lfn$
rem *** Finds record, displays it, searches for next if not OK ***                                       
local n$,I
if lfn$="": let lfn$="Main": endif 
use lfn$: let yes=0
input "who? ";n$
if n$="": return : endif 
find n$
while not yes
if not found(): print n$;" not found": return : endif 
let I=0
while I<numfld(lfn$)
print fieldv(I);":"
let I=I+1
endwhile 
print :YesNo;"OK (y/n)? "
if not yes: continue : endif 
endwhile 
endproc 
proc InFamily;Df$,M,D
rem *** For inputting a family. Default surname is Df$. ***                                    
rem *** RefNo of Mother (M) or Father (D) may be given. ***               
cls 
while 1
use "F": last 
let F.Family=F.Family+1
print "Father is ";
rem (FOR PHASE II) if D:prin;D,0,0: else       
let Sx=1: let Def$=Df$:GetPerson:REM endif       
let F.Father=P.RefNo: let ChN$=P.Surname$
print "Mother is ";
rem (FOR PHASE II) if M:prin;M,0,0: else       
let Sx=0: let Def$="":GetPerson:REM endif       
let F.Mother=P.RefNo
input "Date married? ";F.DateMarried$
input "If divorced, give date... ";F.Dissolved$
let F.Children$=""
YesNo;"Any children? "
while yes
let Def$=ChN$: let Sx=1:GetPerson
let F.Children$=F.Children$+str(P.RefNo,2,0)+","
YesNo;"Any more children? "
endwhile 
use "F": append :UpSubs
rem (FOR PHASE II)let Subject=F.Father:Details;Subject                          
print :YesNo;"Satisfactory? (y/n) "
if yes: return : else 
YesNo;"Delete family just entered?"
if not yes: return : else 
DelFam;F.Family: endif : endif 
endwhile 
endproc 
proc InPerson
rem *** For inputting details of a person (setting defaults) ***            
cls : use "P": last 
let P.RefNo=P.RefNo+1
let P.Surname$=Def$
let P.FirstNames$=""
let P.Male=Sx
let P.DateOfBirth$=""
let P.DateOfDeath$=""
let P.Comments$=""
append : sprint : alter : cls 
endproc 
proc Instructions
rem *** Display instructions for next phase while loading ***            
cls : print ink 2;"Instructions for phase II."
print : print "During this phase family trees may be displayed and changes made to"
print "the database (if files were opened for modifications)."
print : print "The following key presses have the effect shown:"
print : print tab 5;""; ink 4; tab 25;"Subject moves to father (if known)"
print tab 5;"<SHIFT> "; ink 4; tab 25;"Subject moves to mother (if known)"
print tab 5;""; ink 4; tab 25;"Subject moves to eldest sibling (if any)"
print tab 5;""; ink 4; tab 25;"Subject moves to next sibling (if any)"
print tab 5;"="; ink 4; tab 25;"Subject moves to spouse (if any)"
print tab 5;"<SHIFT> = (ie. +)"; ink 4; tab 25;"Subject moves to NEXT spouse. (Only valid after ""="")"
print tab 5;""; ink 4; tab 25;"Subject moves to first child (if any)"
print tab 5;"?"; ink 4; tab 25;"Search for new subject"
print : print tab 5;"<SPACE> or <ENTER>"; ink 4; tab 25;"Display family tree of subject"
print tab 5;"E or <ALT>+any_key"; ink 4; tab 25;"Edit the subject's family"
print tab 5;"I"; ink 4; tab 25;"Insert a new family"
print : print tab 5;"<ESC>"; ink 4; tab 25;"Exit from program."
print at 22,1; ink 2;"Loading..."; at 21,1
endproc 
proc Looks
rem *** Opens the files for read only ***            
print "     Opening files (read only)..."
look Fam$ logical "F"
look Mar$ logical "M"
look Par$ logical "Pa"
look Peo$ logical "P"
endproc 
proc MakeNew
rem *** Start a new database ***                                   
cls : print "     Starting a new database..."
error NewFamilies;Fam$:Check
error NewMarriage;Mar$:Check
error NewParents;Par$:Check
error NewPeople;Peo$:Check
YesNo;"     Do you want to start inputting data?"
while yes
error InFamily;"",0,0
if errnum(): cls : print "***WARNING*** Error ";errnum();" occurred during input of family"
YesNo;"Delete last family?": if yes:DelFam;F.Family: endif : endif 
YesNo;"Another family?"
endwhile 
Mem
endproc 
proc Mem
rem *** Prints remaining memory and No. of records used ***                                                  
cls : print "Total memory remaining =  ";
print memory();" Bytes"
print "RECORDS USED:";
use "P": print tab 15;"People:    ";count()-1
use "M": print tab 15;"Marriages: ";count()-1
use "Pa": print tab 15;"Parents:   ";count()-1
use "F": print tab 15;"Families:  ";count()-1
endproc 
proc NewFamilies;Name$
rem *** New 'Families' file ***                                   
create Name$ logical "F"
Family
Father
Mother
DateMarried$
Dissolved$
Children$
endcreate 
let F.Family=0
append 
order Family;a
endproc 
proc NewMarriage;Name$
rem *** New 'Marriage' file ***                                   
create Name$ logical "M"
RefNo
Family
endcreate 
append 
order RefNo;a
endproc 
proc NewParents;Name$
rem *** New 'Parents' file ***                                   
create Name$ logical "Pa"
RefNo
Family
endcreate 
let RefNo=0
append 
order RefNo;a
endproc 
proc NewPeople;Name$
rem *** New 'People' file ***                                   
create Name$ logical "P"
RefNo
Surname$
FirstNames$
Male
DateOfBirth$
DateOfDeath$
Comments$
endcreate 
let RefNo=0
let P.Surname$="#NULL#"
append 
order RefNo;a
endproc 
proc Opens
rem *** Opens files with write access ***            
print "     Opening files..."
open Fam$ logical "F"
open Mar$ logical "M"
open Par$ logical "Pa"
open Peo$ logical "P"
endproc 
proc Start
rem *** This procedure is called first         ***             
rem *** Opens the files - (new, write or read) ***             
print "Press any key to continue..."
let a$=getkey(): paper 0: mode 0,8: print at 5,1
YesNo;"     Do you want to start a new database? "
FileNames
if yes:MakeNew: error Bye: endif 
YesNo;"     Do you want to modify the database? "
if yes
YesNo;"     Have you backed up the data files? "
if yes
print paper 6; ink 0;"WRITE privilege to files - BEWARE! "
error Opens:Check
else 
print "     Back up files (";Fam$;",";Mar$;",";Par$;",";Peo$;") before continuing"
print "     Press any key to continue..."
let a$=getkey(): mode 1,8: stop 
endif 
else 
error Looks:Check
endif 
let Subject=1
Instructions
run "relat2"
endproc 
proc UpSubs
rem *** Update "Marriage" and "Parents" files ***                                    
use "F"
let M.Family=F.Family
let M.RefNo=F.Father
append "M"
let M.RefNo=F.Mother
append "M"
let Pa.Family=F.Family
let C$=F.Children$
while val(C$)
let Pa.RefNo=val(C$)
append "Pa"
Chop;C$,1,","
endwhile 
endproc 
proc YesNo;P$
rem *** Gets Y or N from keyboard and sets variable "yes"             
while 1
print P$;: let Q$=lower(getkey())
let yes=(Q$="y")
if instr("ny",Q$): print " "+Q$: return : endif 
print : endwhile 
endproc 
